Index: trunk/kernel/syscalls/sys_sem.c
===================================================================
--- trunk/kernel/syscalls/sys_sem.c	(revision 690)
+++ trunk/kernel/syscalls/sys_sem.c	(revision 1)
@@ -2,15 +2,14 @@
  * sys_sem.c - Acces a POSIX unamed semaphore.
  * 
- * Authors     Alain Greiner (2016,2017,2018,2019)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,67 +17,39 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
-#include <shared_semaphore.h>
-#include <errno.h>
-#include <thread.h>
-#include <printk.h>
-#include <vmm.h>
+#include <hal_types.h>
+#include <hal_uspace.
 #include <remote_sem.h>
-#include <syscalls.h>
-
-#if DEBUG_SYS_SEM
-//////////////////////////////////////////////////
-static char * sys_sem_op_str( uint32_t operation )
-{
-  	if     ( operation == SEM_INIT     ) return "INIT";
-  	else if( operation == SEM_WAIT     ) return "WAIT";
-  	else if( operation == SEM_POST     ) return "POST";
-  	else if( operation == SEM_GETVALUE ) return "GETVALUE";
-  	else if( operation == SEM_DESTROY  ) return "DESTROY";
-  	else                                 return "undefined";
-}
-#endif
 
 //////////////////////////////////
-int sys_sem( void         * vaddr,            // semaphore virtual  address 
-             uint32_t       operation,        // requested operation type
-             uint32_t       init_value,       // initial value
-             uint32_t     * current_value )   // pointer on current value buffer
+int sys_sem( void         * vaddr,        // semaphore virtual  address 
+             uint32_t       operation,    // requested operation type
+             uint32_t     * value )       // pointer on in/out argument
 {
-	vseg_t         * vseg;        // for vaddr check
-    error_t          error;
+	uint32_t             data;   
+	error_t              error;
 
-    thread_t       * this    = CURRENT_THREAD;
-    process_t      * process = this->process;
-
-#if (DEBUG_SYS_SEM || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_SEM
-if( DEBUG_SYS_SEM < tm_start )
-printk("\n[DBG] %s : thread %x in process %x enter for %s / cycle %d\n",
-__FUNCTION__, this->trdid, process->pid, sys_sem_op_str( operation ), (uint32_t)tm_start );
-#endif
+    thread_t           * this      = CURRENT_THREAD;
+	process_t          * process   = CURRENT_PROCESS;
 
     // check vaddr in user vspace
-	error = vmm_get_vseg( process , (intptr_t)vaddr , &vseg );
-	if( error )
+	error = vmm_check_address( process , vaddr , sizeof(unsigned long) );
+	if( error ) 
     {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : unmapped semaphore pointer %x / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)vaddr, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
-        this->errno = EINVAL;
+        this->errno = error;
         return -1;
     }
 
+    // check value in user vspace
+    error = vmm_check_address( process , value , sizeof(int*) );
+	if( error ) 
+    {
+        this->errno = error;
+        return -1;   
+    }
+    
     // execute requested operation
 	switch( operation )
@@ -87,157 +58,100 @@
 	    case SEM_INIT:
         {
-            // call relevant kernel function to initialize semaphore
-            error = remote_sem_create( (intptr_t)vaddr , 
-                                       init_value );
+            // get argument
+		    hal_copy_from_uspace( &data , value , sizeof(uint32_t) );
+
+            // call init function
+            error = remote_sem_init( (intptr_t)vaddr , data );
+
             if ( error )
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s INIT: cannot create semaphore / thread %x in process %x / cycle %d\n",
-__FUNCTION__, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
-                this->errno = ENOMEM;
+                this->errno = error;
                 return -1;
             }
+            break;
         }
-        break;
         //////////////////
         case SEM_GETVALUE:
         {
-            // check current_value buffer in user vspace
-	        error = vmm_get_vseg( process , (intptr_t)current_value , &vseg );
-            if( error )
+            // get extended pointer on remote semaphore
+            xptr_t sem_xp = remote_sem_from_vaddr( (intptr_t)vaddr );
+
+            if( sem_xp == XPTR_NULL )     // user error
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s GETVALUE: unmapped buffer %x / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)current_value, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
                 this->errno = EINVAL;
                 return -1;
             }
-
-            // get extended pointer on remote semaphore
-            xptr_t sem_xp = remote_sem_from_ident( (intptr_t)vaddr );
-
-            // check semaphore registered
-            if( sem_xp == XPTR_NULL )
+            else                          // success
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s GETVALUE: semaphore %x not found / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)vaddr, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
-                this->errno = EINVAL;
-                return -1;
+                // get semaphore current value
+		        remote_sem_get_value( sem_xp , &data );
+ 
+                // return value to user
+                hal_copy_to_uspace( value , &data , sizeof(uint32_t) );
             }
-
-            // call relevant kernel function to get semaphore current value
-            uint32_t current;
-		    remote_sem_get_value( sem_xp , &current );
- 
-            // return value to user
-            hal_copy_to_uspace( current_value,
-                                XPTR( local_cxy , &current ),
-                                sizeof(uint32_t) );
+            break;
         }
-        break;
         //////////////
 	    case SEM_WAIT:
         {  
             // get extended pointer on remote semaphore
-            xptr_t sem_xp = remote_sem_from_ident( (intptr_t)vaddr );
+            xptr_t sem_xp = remote_sem_from_vaddr( (intptr_t)vaddr );
 
-            // check semaphore registered
-            if( sem_xp == XPTR_NULL )
+            if( sem_xp == XPTR_NULL )     // user error
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s WAIT: semaphore %x not found / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)vaddr, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
                 this->errno = EINVAL;
                 return -1;
             }
-
-            // call relevant kernel function to wait semaphore available
-            remote_sem_wait( sem_xp );
+            else                          // success
+            {
+                // wait semaphore available
+                remote_sem_wait( sem_xp );
+            }
+            break;
         }
-        break;
         //////////////
 	    case SEM_POST:
         {
             // get extended pointer on remote semaphore
-            xptr_t sem_xp = remote_sem_from_ident( (intptr_t)vaddr );
+            xptr_t sem_xp = remote_sem_from_vaddr( (intptr_t)vaddr );
 
-            // check semaphore registered
-            if( sem_xp == XPTR_NULL )
+            if( sem_xp == XPTR_NULL )     // user error
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s POST: semaphore %x not found / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)vaddr, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
                 this->errno = EINVAL;
                 return -1;
             }
-
-            // call relevant kernel function to release semaphore 
-            remote_sem_post( sem_xp );
+            else                          // success
+            {
+                // release semaphore 
+                remote_sem_post( sem_xp );
+            }
+			break;
         }
-		break;
         /////////////////
 	    case SEM_DESTROY:
         {
             // get extended pointer on remote semaphore
-            xptr_t sem_xp = remote_sem_from_ident( (intptr_t)vaddr );
+            xptr_t sem_xp = remote_sem_from_vaddr( (intptr_t)vaddr );
 
-            // check semaphore registered
-            if( sem_xp == XPTR_NULL )
+            if( sem_xp == XPTR_NULL )     // user error
             {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s DESTROY: semaphore %x not found / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , (intptr_t)vaddr, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
                 this->errno = EINVAL;
                 return -1;
             }
-
-            // destroy semaphore
-            remote_sem_destroy( sem_xp );
+            else                          // success 
+            {
+                // destroy semaphore
+                remote_sem_destroy( sem_xp );
+            }
+            break;
 	    }	
-        break;
         ///////
 	    default:  // undefined operation                       
         {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : undefined operation type %d / thread %x in process %x / cycle %d\n",
-__FUNCTION__ , operation, this->trdid, process->pid, (uint32_t)hal_get_cycles() );
-#endif
-            this->errno = EINVAL;
+		    this->errno = EINVAL;
             return -1;
         }
 	}
 
-    hal_fence();
-
-#if (DEBUG_SYS_SEM || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_SEM
-if( DEBUG_SYS_SEM < tm_end )
-printk("\n[DBG] %s : thread %x in process %x exit for %s / cost = %d / cycle %d\n",
-__FUNCTION__, this->trdid, process->pid, sys_sem_op_str( operation ),
-(uint32_t)(tm_end - tm_start), (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_SEM] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_SEM] , 1 );
-#endif
-
     return 0;
 
Index: trunk/kernel/syscalls/sys_signal.c
===================================================================
--- trunk/kernel/syscalls/sys_signal.c	(revision 690)
+++ trunk/kernel/syscalls/sys_signal.c	(revision 1)
@@ -1,9 +1,7 @@
 /*
- * sys_signal.c - associate a specific signal handler to a given signal.
+ * sys_sem.c: interface to access signal service
  * 
- * Authors   Ghassan Almaless (2008,2009,2010,2011,2012)
- *           Alain Greiner (2016,2017)
- *
- * Copyright (c) UPMC Sorbonne Universites
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012,2013,2014,2015 UPMC Sorbonne Universites
  *
  * This file is part of ALMOS-kernel.
@@ -23,21 +21,73 @@
  */
 
-#include <hal_kernel_types.h>
+#include <types.h>
 #include <errno.h>
 #include <thread.h>
-#include <printk.h>
+#include <task.h>
+#include <pid.h>
+#include <signal.h>
 
-#include <syscalls.h>
 
-//////////////////////////////////
-int sys_signal( uint32_t   sig_id,
-                void     * handler )
-{
-    thread_t  * this    = CURRENT_THREAD;
-    process_t * process = this->process;
+int sys_signal(uint_t sig, sa_handler_t *handler)
+{  
+	register struct thread_s *this;
+	int retval;
 
-    printk("\n[ERROR] in %s : thread %x in process %x / not implemented yet\n", 
-    __FUNCTION__, this->trdid, process->pid, sig_id, handler );
-    return ENOSYS;
+	this = current_thread;
+
+	if((sig == 0) || (sig >= SIG_NR) || (sig == SIGKILL) || (sig == SIGSTOP))
+	{
+		this->info.errno = EINVAL;
+		return SIG_ERROR;
+	}
+
+	retval = (int) this->task->sig_mgr.sigactions[sig];
+	this->task->sig_mgr.sigactions[sig] = handler;
+
+	sig_dmsg(1, "%s: handler @%x has been registred for signal %d\n",
+	       __FUNCTION__, 
+	       handler, 
+	       sig);
+
+	return retval;
 }
 
+
+int sys_sigreturn_setup(void *sigreturn_func)
+{
+	struct thread_s *this;
+
+	this = current_thread;
+	this->info.attr.sigreturn_func = sigreturn_func;
+	cpu_context_set_sigreturn(&this->pws, sigreturn_func);
+	return 0;
+}
+
+
+int sys_kill(pid_t pid, uint_t sig)
+{
+        cid_t   location;
+	error_t err;
+
+	if((sig == 0) || (sig >= SIG_NR))
+	{
+		err = EINVAL;
+	}
+        else
+        {
+                if ( PID_GET_CLUSTER(pid) == current_cid )
+                        location = current_cid;
+                else
+                        location = task_whereis(pid);
+
+                err = signal_rise(pid, location, sig);
+
+                /* No error, return 0 */
+                if (!err)
+                        return 0;
+        }
+
+        /* Error. Set errno and return */
+	current_thread->info.errno = err;
+	return -1;
+}
Index: trunk/kernel/syscalls/sys_stat.c
===================================================================
--- trunk/kernel/syscalls/sys_stat.c	(revision 690)
+++ trunk/kernel/syscalls/sys_stat.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_stat.c - kernel function implementing the "stat" syscall.
+ * kern/sys_stat.c - stats a file or directory
  * 
- * Author    Alain Greiner  (2016,2017,2018,2019)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,133 +17,64 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
-#include <hal_special.h>
 #include <errno.h>
 #include <thread.h>
-#include <printk.h>
 #include <vfs.h>
-#include <vmm.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
+#include <spinlock.h>
+#include <cpu-trace.h>
 
-#include <syscalls.h>
 
-/////////////////////////////////////
-int sys_stat( char        * pathname,
-              struct stat * u_stat )
+int sys_stat(char *pathname, struct vfs_stat_s *buff, int fd)
 {
-    error_t       error;
-    vseg_t      * vseg;                   // for user space checking
-    struct stat   k_stat;                 // in kernel space 
-    xptr_t        root_inode_xp;          // extended pointer on path root inode
+	CPU_HW_TRACE(sys_stat);
+	struct thread_s *this;
+	register error_t err = 0;
+	struct vfs_file_s *file;
+	struct ku_obj ku_path;
+	struct task_s *task;
 
-    char          kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
-	
-	thread_t  * this    = CURRENT_THREAD;
-	process_t * process = this->process;
+	file = NULL;
+	this = current_thread;
+	task = current_task;
 
-#if (DEBUG_SYS_STAT || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-    // check stat structure in user space
-    error = vmm_get_vseg( process , (intptr_t)u_stat , &vseg );
-
-	if( error )
+	if((buff == NULL) || ((pathname == NULL) && (fd == -1)))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s / thread[%x,%x] : stat structure %x unmapped\n",
-__FUNCTION__ , process->pid , this->trdid, u_stat );
-#endif
-		this->errno = EINVAL;
-		return -1;
-	}	
-
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s / thread[%x,%x] : pathname too long\n",
- __FUNCTION__ , process->pid , this->trdid );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-#if DEBUG_SYS_STAT
-if( DEBUG_SYS_STAT < tm_start )
-printk("\n[%s] thread[%x,%x] enter for file <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_start );
-#endif
-
-    // compute root inode for path 
-    if( kbuf[0] == '/' )                        // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                        // relative path
-    {
-        // get cluster and local pointer on reference process
-        xptr_t      ref_xp  = process->ref_xp;
-        process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
-        cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
-    }
-
-    // call the relevant VFS function
-    error = vfs_stat( root_inode_xp,
-                      kbuf,
-                      &k_stat ); 
-    if( error )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s / thread[%x,%x] : cannot get stats for inode <%s>\n",
-__FUNCTION__ , process->pid , this->trdid , pathname );
-#endif
-		this->errno = ENFILE;
+		this->info.errno = EINVAL;
+		CPU_HW_TRACE(sys_stat);
 		return -1;
 	}
-   
-    // copy k_stat to u_stat 
-    hal_copy_to_uspace( u_stat,
-                        XPTR( local_cxy , &k_stat ),
-                        sizeof(struct stat) );
 
-    hal_fence();
+	if(NOT_IN_USPACE((uint_t)buff))
+	{
+		this->info.errno = EPERM;
+		CPU_HW_TRACE(sys_stat);
+		return -1;
+	}
 
-#if (DEBUG_SYS_STAT || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_STAT
-if( DEBUG_SYS_STAT < tm_end )
-printk("\n[%s] thread[%x,%x] exit for file <%s> / size %d / mode %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf,
-k_stat.st_size, k_stat.st_mode, (uint32_t)tm_end );
-#endif
+	if(pathname == NULL)
+	{
+		if((fd >= CONFIG_TASK_FILE_MAX_NR) || (task_fd_lookup(task, fd, &file)))
+		{
+			CPU_HW_TRACE(sys_stat);
+			return EBADFD;
+		}
  
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_STAT] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_STAT] , 1 );
-#endif
-
+		err = vfs_stat(&task->vfs_cwd, NULL, buff, file);
+	}
+	else
+	{
+		KU_BUFF(ku_path, pathname);
+		rwlock_rdlock(&task->cwd_lock);
+		err = vfs_stat(&task->vfs_cwd, &ku_path, buff, NULL);
+		rwlock_unlock(&task->cwd_lock);
+	}
+ 
+	this->info.errno = err;
+	CPU_HW_TRACE(sys_stat);
 	return 0;
-
-}  // end sys_stat()
-
+}
Index: trunk/kernel/syscalls/sys_thread_create.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_create.c	(revision 690)
+++ trunk/kernel/syscalls/sys_thread_create.c	(revision 1)
@@ -1,6 +1,8 @@
 /*
  * sys_thread_create.c - creates a new user thread
- *
- * Author     Alain Greiner (2016,2017,2018,2019)
+ * 
+ * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *         Mohamed lamine Karaoui (2015)
+ *         Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -22,8 +24,6 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <printk.h>
 #include <errno.h>
@@ -36,193 +36,122 @@
 #include <kmem.h>
 #include <process.h>
+#include <spinlock.h>
 #include <dqdt.h>
-#include <rpc.h>
 
-#include <syscalls.h>
 
-/////////////////////////////////////////////////////////
-int sys_thread_create( trdid_t               * trdid_ptr,
-                       struct pthread_attr_s * user_attr,
-                       void                  * start_func,
-                       void                  * start_args )
+//////////////////////////////////////////////////////////////////////////////////////////
+// This function implements the pthread_create system call
+//////////////////////////////////////////////////////////////////////////////////////////
+int sys_thread_create ( thread_t       * new_thread,    // [out] argument
+                        pthread_attr_t * user_attr,     // [in] argument
+                        void           * start_func,    // [in] argument
+                        void           * start_args )   // [in] argument
 {
-    pthread_attr_t   kern_attr;        // copy of pthread attributes in kernel space
-    thread_t       * parent;           // pointer on thread executing the pthread_create
-    cxy_t            child_cxy;        // created child thread cluster identifier
-    thread_t       * child_ptr;        // pointer on created child thread
-    xptr_t           child_xp;         // extended pointer on created thread
+	pthread_attr_t   attr;             // copy of pthread attributes in kernel space
+	thread_t       * parent;           // pointer on thread executing the pthread_create
+    xptr_t           xp_parent;        // extended pointer on created thread
+    thread_t       * child;            // pointer on created child thread
+    xptr_t           xp_child;         // extended pointer on created thread
     trdid_t          trdid;            // created thread identifier
     process_t      * process;          // pointer on local process descriptor
-    vseg_t         * vseg;             // required for user space checking
     error_t          error;
 
-    // get parent thead pointer, extended pointer, and process 
-    parent     = CURRENT_THREAD;
-    process    = parent->process;
+	uint32_t         tm_start;
+	uint32_t         tm_end;
 
-#if (DEBUG_SYS_THREAD_CREATE || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	tm_start = hal_time_stamp();
 
-#if DEBUG_SYS_THREAD_CREATE
-if( DEBUG_SYS_THREAD_CREATE < tm_start )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__, process->pid, parent->trdid, (uint32_t)tm_start );
-#endif
+    // get parent thead pointer, extended pointer, and process pointer
+	parent     = CURRENT_THREAD;
+    xp_parent  = XPTR( local_cxy , parent );    
+	process    = parent->process;
 
-    // check trdid buffer in user space
-    if( vmm_get_vseg( process , (intptr_t)trdid_ptr , &vseg ) )
+    // check user_attr & start_func arguments
+	if( user_attr == NULL )
+	{
+		printk("\n[ERROR] in %s : user_attr is NULL\n", __FUNCTION__ );
+		return EINVAL;
+	}
+	if( start_func== NULL )
+	{
+		printk("\n[ERROR] in %s : start_func is NULL\n", __FUNCTION__ );
+		return EINVAL;
+	}
+
+    // copy user_attr structure to kernel space
+	hal_copy_from_uspace( &attr , user_attr , sizeof(pthread_attr_t) );
+
+    // check/set "cxy" attribute
+	if( attr.flags & PT_FLAG_CLUSTER_DEFINED ) 
     {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / trdid buffer %x unmapped %x\n",
-__FUNCTION__, process->pid, parent->trdid, (intptr_t)trdid_ptr );
-#endif
-		parent->errno = EINVAL;
-		return -1;
+        if( cluster_is_undefined( attr.cxy ) )
+        {
+		    printk("\n[ERROR] in %s : illegal target cluster = %x\n",
+                   __FUNCTION__ , attr.cxy );
+		    return = EINVAL;
+        } 
+    }
+    else
+    {
+        attr.cxy = dqdt_get_cluster_for_process();
     }
 
-	// check user_attr buffer in user space & copy to kernel space
-    if( user_attr != NULL )
+    // set "pid", "start_func" & "start_args" attributes
+    attr.pid        = process->pid;
+    attr.start_func = start_func;
+    attr.start_args = start_args;
+
+    // create the thread, using a RPC if required
+    // this returns "error", "child", and "xp_child" 
+    if( attr.cxy == local_cxy )                 // target cluster is local 
     {
-	    if( vmm_get_vseg( process , (intptr_t)user_attr , &vseg ) )
-	    {
+        // allocate a stack from local VMM 
+        vseg_t * vseg = vmm_create_vseg( process, 
+                                         0,
+                                         0,
+                                         VSEG_TYPE_STACK,
+                                         local_cxy );
+        if( vseg == NULL )
+        {
+		    printk("\n[ERROR] in %s for : cannot create stack vseg\n", __FUNCTION__ );
+		    return = EINVAL;
+        } 
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / user_attr buffer unmapped %x\n",
-__FUNCTION__, process->pid, parent->trdid, (intptr_t)user_attr );
-#endif
-		    parent->errno = EINVAL;
-		    return -1;
-	    }
-        
-	    hal_copy_from_uspace( XPTR( local_cxy , &kern_attr ),
-                              user_attr,
-                              sizeof(pthread_attr_t) );
+        // create thread in local cluster
+        error = thread_user_create( &child,
+                                    &attr,
+                                    vseg->min,
+                                    vseg->max - vseg->min );
+
+        xp_child = XPTR( local_cxy , thread );
+    }
+    else                                                 // target cluster is remote
+    {
+        rpc_thread_user_create( attr.cxy , &attr , &error , &xp_child );
+        child = (thread_t *)GET_PTR( xp_child );
     }
 
-	// check start_func in user space
-	if( vmm_get_vseg( process , (intptr_t)start_func , &vseg ) )
+    // check successful thread creation
+    if( error ) 
     {
+		printk("\n[ERROR] in %s : cannot create thread\n", __FUNCTION__ );
+        return ENOMEM;
+    }
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / start_func unmapped %x\n",
-__FUNCTION__, process->pid, parent->trdid, (intptr_t)start_func );
-#endif
-        parent->errno = EINVAL;
-	    return -1;
-	}
+    // returns trdid to user space 
+    trdid = hal_remote_lw( XPTR( attr.cxy , &child->trdid ) );   
+	hal_copy_to_uspace( new_thread , &trdid , sizeof(pthread_t) );
+    
+    // register new-thread in parent-thread children list if required
+    if( attr.flags & PT_FLAG_DETACH == 0 ) thread_child_parent_link( xp_parent , xp_child );
 
-	// check start_args buffer in user space
-	if( start_args != NULL )
-    {
-        if( vmm_get_vseg( process , (intptr_t)start_args , &vseg ) )
-	    {
+	tm_end = hal_time_stamp();
 
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / start_args buffer unmapped %x\n",
-__FUNCTION__, process->pid, parent->trdid, (intptr_t)start_args );
-#endif
-		    parent->errno = EINVAL;
-		    return -1;
-        }
-	}
-
-    // define attributes and child_cxy
-    if( user_attr != NULL )                      // user defined attributes
-    {
-	    // check / get child_cxy
-	    if( kern_attr.attributes & PT_ATTR_CLUSTER_DEFINED )
-	    {
-		    if( cluster_is_active( kern_attr.cxy ) == false )
-		    {
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] / illegal target cluster %x\n",
-__FUNCTION__, process->pid, parent->trdid, kern_attr.cxy );
-#endif
-			    parent->errno = EINVAL;
-			    return -1;
-            }
-            child_cxy = kern_attr.cxy;
-		}
-        else
-        {
-            child_cxy = dqdt_get_cluster_for_thread( LOCAL_CLUSTER->dqdt_root_xp );
-        }
-	}
-	else                                        // set default attributes
-	{
-        kern_attr.attributes = PT_ATTR_CLUSTER_DEFINED;
-        child_cxy = dqdt_get_cluster_for_thread( LOCAL_CLUSTER->dqdt_root_xp );
-	}
-
-	// create the thread, using a RPC if required
-	// this returns "error", "child_ptr", and "child_xp"
-
-	if( child_cxy == local_cxy )                         // target cluster is local
-	{
-		// create thread in local cluster
-		error = thread_user_create( process->pid,
-		                            start_func,
-		                            start_args,
-		                            &kern_attr,
-		                            &child_ptr );
-
-		child_xp = XPTR( local_cxy , child_ptr );
-	}
-	else                                                 // target cluster is remote
-	{
-		rpc_thread_user_create_client( child_cxy,
-		                               process->pid,
-		                               start_func,
-		                               start_args,
-		                               &kern_attr,
-		                               &child_xp,
-		                               &error );
-
-		child_ptr = (thread_t *)GET_PTR( child_xp );
-	}
-
-	// check successful thread creation
-	if( error )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create new thread\n",
-__FUNCTION__ , process->pid, parent->trdid );
-#endif
-		parent->errno = ENOMEM;
-		return -1;
-	}
-
-	// returns trdid to user space
-	trdid = hal_remote_l32( XPTR( child_cxy , &child_ptr->trdid ) );
-	hal_copy_to_uspace( trdid_ptr,
-                        XPTR( local_cxy , &trdid ),
-                        sizeof(pthread_t) );
-
-    // activate new thread
-	thread_unblock( child_xp , THREAD_BLOCKED_GLOBAL );
-
-    hal_fence();
-
-#if (DEBUG_SYS_THREAD_CREATE || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_THREAD_CREATE
-if( DEBUG_SYS_THREAD_CREATE < tm_end )
-printk("\n[%s] thread[%x,%x] created thread %x / cycle %d\n",
-__FUNCTION__, process->pid, parent->trdid, child_ptr->trdid, (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_THREAD_CREATE] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_THREAD_CREATE] , 1 );
-#endif
-
+	thread_dmsg("\n[INFO] %s created thread %x for process %x in cluster %x\n"
+                "  start_cycle = %d / end_cycle = %d\n",
+                   trdid , process->pid , attr.cxy , tm_start , tm_end );
 	return 0;
 
 }  // end sys_thread_create()
 
+
